//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "AIOUSB.h"

#include "MainUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
#pragma pack(push, 1)
typedef struct _T8254CounterWDG  // one 16-bit counter's control block
{
  BYTE mode;     // 0-5
  BYTE flagload; // bytebool, true causes the WDG to issue a LOAD in addition to the MODE command
  BYTE LSB;      // LSB of the divisor to LOAD (when flagload is TRUE)
  BYTE MSB;      // MSB ""
} T8254CounterWDG;

typedef struct _TWatchdogConfigUSB
{
  WORD Timeout;
  T8254CounterWDG ctr[15];
} TWatchdogConfigUSB;
#pragma pack(pop)
//---------------------------------------------------------------------------
unsigned char BuildModeCommand(int CounterIndex, int Mode)
{
        CounterIndex = CounterIndex % 3; //Convert from all-block-zero to per-block counter indexing, if needed.
        return (CounterIndex << 6) | (Mode << 1) | 0x30;
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
        CTRDeviceIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::watchDogConfigUSB() // 04/26/19 NJM - NEW module for setting WDC on USB-CTR-15 - HOW TO TEST???
{
        CTR_8254Mode(CTRDeviceIndex, 0, 3, 0);
        for (int aCTR=0; aCTR < 15; aCTR++)
                CTR_8254Mode(CTRDeviceIndex, 0, aCTR, 1)
        ;
        CTR_8254Mode(CTRDeviceIndex, 0, 3, 0);

        TWatchdogConfigUSB WatchdogConfigUSB;
        WatchdogConfigUSB.Timeout = 12; // timeout in seconds * 2

        for (int aCTR=0; aCTR < 15; aCTR++)    // John H had this as ++aCTR ???
        {
                WatchdogConfigUSB.ctr[aCTR].mode = BuildModeCommand(aCTR, 0);
                WatchdogConfigUSB.ctr[aCTR].flagload = 0;
                WatchdogConfigUSB.ctr[aCTR].LSB = 0;
                WatchdogConfigUSB.ctr[aCTR].MSB = 0;
        }

        WatchdogConfigUSB.ctr[3].mode = BuildModeCommand(3, 1); // 0 = set low 1 = set high
        WatchdogConfigUSB.ctr[3].flagload = 0; // 0 = Not Load and 1 = Load
        GenericVendorWrite(CTRDeviceIndex, 0x2E, 0, 0, sizeof(WatchdogConfigUSB), &WatchdogConfigUSB);
        //unsigned long DataSize = sizeof(WatchdogConfigUSB);
        //GenericVendorRead(CTRDeviceIndex, 0x2E, 0, 0, &DataSize, &WatchdogConfigUSB);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PollTimeTimer(TObject *Sender)
{
        unsigned short ReadValue = 0;
        CTR_8254Read(CTRDeviceIndex, 0, 3, &ReadValue);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PollCheckClick(TObject *Sender)
{
        PollTime->Enabled = PollCheck->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
        watchDogConfigUSB();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
        CTR_8254Mode(CTRDeviceIndex, 0, 2, 0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
        CTR_8254Mode(CTRDeviceIndex, 0, 2, 1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
        CTR_8254Mode(CTRDeviceIndex, 0, 3, 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
        CTR_8254Mode(CTRDeviceIndex, 0, 3, 1);
}
//---------------------------------------------------------------------------

